package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Preconditions;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.BiFunction;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.item.ItemStack;

public class DurabilityBonus extends GemBonus {
  public static Codec<dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.DurabilityBonus> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group(gemClass(), (App)VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.DurabilityBonus::new));
  }
  
  public DurabilityBonus(GemClass gemClass, Map<LootRarity, StepFunction> values) {
    super(Apotheosis.loc("durability"), gemClass);
    this.values = values;
  }
  
  public Component getSocketBonusTooltip(ItemStack gem, LootRarity rarity) {
    float level = ((StepFunction)this.values.get(rarity)).get(0.0F);
    return (Component)Component.m_237110_("bonus." + getId() + ".desc", new Object[] { Affix.fmt(100.0F * level) }).m_130940_(ChatFormatting.YELLOW);
  }
  
  public float getDurabilityBonusPercentage(ItemStack gem, LootRarity rarity, ServerPlayer user) {
    return ((StepFunction)this.values.get(rarity)).min();
  }
  
  public GemBonus validate() {
    Preconditions.checkNotNull(this.values, "Invalid AttributeBonus with null values");
    return this;
  }
  
  public boolean supports(LootRarity rarity) {
    return this.values.containsKey(rarity);
  }
  
  public int getNumberOfUUIDs() {
    return 0;
  }
  
  public Codec<? extends GemBonus> getCodec() {
    return (Codec)CODEC;
  }
}
